// ReadThis! Key method
//
// Copyright (C) 1999 by Schachar Levin <pixel.il@usa.net>.  All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
// 1. Redistributions of source code must retain the above copyright
//    notice, this list of conditions and the following disclaimer.
// 2. Redistributions in binary form must reproduce the above copyright
//    notice, this list of conditions and the following disclaimer in the
//    documentation and/or other materials provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
// ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
// FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
// DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
// OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
// LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
// OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
// SUCH DAMAGE.


package ReadThis;
import Acme.Crypto.*;
import java.security.*;

public class RTKey
{
	
	private byte[] key;
	private long keyID;
	public long getKeyID()
	{
		return (keyID&0xffffffff);
	}
	public byte[] getKey()
	{
		return key;
	}
	public void setKey()
	{
		this.keyID=0;
		this.key=null;
	}
	public void setKey(String phrase)
	{
		byte[] keyID;
		byte tmp;
		if(phrase==null)
		{
			this.keyID=0;
			this.key=null;
			return;
		}
		MD5 m=new MD5(phrase);
		key=m.Final();
		m=new MD5();
		m.Update(key);
		keyID=m.Final();
		this.keyID=ByteToLong(keyID);
	}
	public RTKey()
	{
		keyID=0;
	}
	public RTKey(String phrase)
	{
	setKey(phrase);
	}
	protected long ByteToLong(byte[] b)
	{
		long l;
		l=(b[12]&0xff)<<24;
		l+=(b[13]&0xff)<<16;
		l+=(b[14]&0xff)<<8;
		l+=b[15]&0xff;
		return l;
	}
}
